function net = chDataModel(sourceModelPath, numGroups)

net = load(sourceModelPath) ;
net = dagnn.DagNN.loadobj(net.net) ;

net.removeLayer('accuracy') ;

preLayers = [];
preLayers = [preLayers net.getLayerIndex('predict5')] ;
for l = 1:numel(net.layers)
  if strfind(net.layers(l).name, 'skip') == 1
    preLayers = [preLayers l];
  end
end
if ~isempty(net.getLayerIndex('convfinal'))
  preLayers = [preLayers net.getLayerIndex('convfinal')] ;
else
  preLayers = [preLayers net.getLayerIndex('prediction')] ;
end

for i = 1:preLayers(1)
  if (isa(net.layers(i).block, 'dagnn.Conv') && net.layers(i).block.hasBias)
    filt = net.getParamIndex(net.layers(i).params{1}) ;
    bias = net.getParamIndex(net.layers(i).params{2}) ;
    net.params(filt).learningRate = net.params(filt).learningRate / 100 ;
    net.params(bias).learningRate = 2 * net.params(filt).learningRate ;
  end
end

for i = preLayers

  net.layers(i).block.size(end) = numGroups;
  if i == preLayers(end)
    net.layers(i).block.size(end - 1) = numGroups * 5;
  end

  filt = net.getParamIndex(net.layers(i).params{1}) ;
  net.params(filt).value = single(normrnd(0, 0.01, net.layers(i).block.size));
  
  bias = net.getParamIndex(net.layers(i).params{2}) ;
  szb = size(net.params(bias).value) ;
  szb(end) = numGroups;
  net.params(bias).value = zeros(szb, 'single') ;
end

if length(preLayers) > 1
  for j = preLayers(2 : end - 1)
    net.layers(j+1).block.size(end) = numGroups;
    net.layers(j+1).block.numGroups = numGroups;
    par = net.getParamIndex(net.layers(j+1).params);
    sz = size(net.params(par).value) ;
    net.params(par).value = single(bilinear_u(sz(1), numGroups, numGroups)) ;
  end
end

net.addLayer('accuracy', ...
  SegmentationAccuracy('numGroups', numGroups), ...
  {'prediction', 'label'}, 'accuracy') ;
