function fccnTrain(varargin)

% addpath(genpath('/home/autolab/Documents/matconvnet-master'));

% run vl_setupnn ;

opts.sourceModelPath = 'data/fccn10-ade20k/net-epoch-50.mat' ;

load(opts.sourceModelPath, 'net', 'opts') ;
net = dagnn.DagNN.loadobj(net) ;

opts.train.gpus = [2] ;

opts.train.learningRate = 0.0001 * ones(1,100) ;
opts.train.numEpochs = numel(opts.train.learningRate) ;

% -------------------------------------------------------------------------
% Setup data
% -------------------------------------------------------------------------

% segmentations
if exist(opts.imdbPath)
  imdb = load(opts.imdbPath) ;
else
  display(['fail to read imdb data']);
  return;
end

% Get training and test/validation subsets
train = find(imdb.images.segmentation) ;
val = find(imdb.images.set == 2 & imdb.images.segmentation) ;

% Get dataset statistics
if exist(opts.imdbStatsPath)
  stats = load(opts.imdbStatsPath) ;
else
  stats = getDatasetStatistics(imdb) ;
  save(opts.imdbStatsPath, '-struct', 'stats') ;
end

net.meta.normalization.rgbMean = stats.rgbMean ;
net.meta.classes = imdb.classes.name ;

% -------------------------------------------------------------------------
% Train
% -------------------------------------------------------------------------

% Setup data fetching options
bopts.numThreads = opts.numFetchThreads ;
bopts.labelStride = 1 ;
bopts.labelOffset = 1 ;
bopts.classWeights = ones(1,opts.numGroups,'single') ;
bopts.rgbMean = stats.rgbMean ;
bopts.useGpu = numel(opts.train.gpus) > 0 ;


% Launch SGD
info = cnn_train_dag(net, imdb, getBatchWrapper(bopts), ...
                     opts.train, ....
                     'train', train, ...
                     'val', val, ...
                     'derOutputs', opts.derOutputs, ...
                     opts.train) ;

% -------------------------------------------------------------------------
function fn = getBatchWrapper(opts)
% -------------------------------------------------------------------------
fn = @(imdb,batch) getBatch(imdb,batch,opts,'prefetch',nargout==0) ;
