function net = fcnDeconvSimInitModel(varargin)
%FCNINITIALIZEMODEL Initialize the FCN-32 model from VGG-VD-16

opts.sourceModelPath = 'data/fcnDeconv-voc11/net-epoch-50.mat' ;
opts.numGroups = 21; 
% opts = vl_argparse(opts, varargin) ;

if ~exist(opts.sourceModelPath)
  disp('No sourceModel!');
  quit;
end

net = load(opts.sourceModelPath) ;

net = dagnn.DagNN.loadobj(net.net) ;

layerNames = [];
layerNums = [];
for l = 1:numel(net.layers)
  if strfind(net.layers(l).name, '_2') >= 1
    layerNames = [layerNames, {net.layers(l).name}];
    layerNums = [layerNums, l];
  elseif strfind(net.layers(l).name, '_3') >= 1
    layerNames = [layerNames, {net.layers(l).name}];
    layerNums = [layerNums, l];
  end
end

if numel(layerNames) > 0
  for i = 1 : numel(layerNames)
    net.layers(layerNums(i)-1).outputs = net.layers(layerNums(i)).outputs;
    net.removeLayer(layerNames{i});
    layerNums = layerNums - 1;
  end
end