function reset(obj)
%RESET Reset the DagNN
%   RESET(obj) resets the DagNN obj. The function clears any intermediate value stored in the DagNN
%   object, including parameter gradients. It also calls the reset
%   function of every layer.

[obj.vars.value] = deal([]) ;
[obj.vars.der] = deal([]) ;
[obj.params.der] = deal([]) ;

for l = 1:numel(obj.layers)
  obj.layers(l).block.reset() ;
  if isprop(obj.layers(l).block, 'inputNum')	% added by yangtao 2017.06.03
  	obj.layers(l).block.average = zeros(obj.layers(l).block.inputNum, 1);
  end
end
